package com.liantis.octopusplugin;

import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import com.nomagic.magicdraw.actions.MDAction;
import com.nomagic.magicdraw.core.Application;
import com.nomagic.magicdraw.core.Project;
import com.nomagic.uml2.ext.magicdraw.auxiliaryconstructs.mdmodels.Model;

class ExportAction extends MDAction
{
	static File defaultDirectory = null;
	
	public ExportAction(String id, String name)
	{
		super(id, name, null, null);
	}

	public void actionPerformed(ActionEvent e)
	{
	   
	   try {
	      Project project = Application.getInstance().getProject();
	      if(project != null) {
	         String pFilename = project.getFileName();
	         if(pFilename.indexOf('.') >= 0) {
	        	 
	        	 JFileChooser fileChooser = new JFileChooser(defaultDirectory);
	        	 fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	        	 if(fileChooser.showDialog(this.getSelectedWindow(Frame.getFrames()),"Select Octopus Model Directory") == JFileChooser.APPROVE_OPTION) {
	        		 
	        		 defaultDirectory = fileChooser.getSelectedFile();
	        		 Model root = project.getModel();
	        		 OctopusWriter octopusWriter = new OctopusWriter();
	        		 octopusWriter.writeModel(defaultDirectory,root);
	        	 }
	         }
	         else {
	            JOptionPane.showMessageDialog(this.getSelectedWindow(Frame.getFrames()),"please save project first");        	            
	         }
	      }
	      else {
	         JOptionPane.showMessageDialog(this.getSelectedWindow(Frame.getFrames()),	"please open project first");        
	      }
	   }
	   catch(Exception ex)
	   {
	      ex.printStackTrace();
	      JOptionPane.showMessageDialog(this.getSelectedWindow(Frame.getFrames()),	"exception during Octopus export - see log file MD_LOG in magic draw home directory for details");	      
	   }	   
	}
    
   private Window getSelectedWindow(Window[] windows) {
       Window result = null;
       for (int i = 0; i < windows.length; i++) {
           Window window = windows[i];
           if (window.isActive()) {
               result = window;
           } else {
               Window[] ownedWindows = window.getOwnedWindows();
               if (ownedWindows != null) {
                   result = getSelectedWindow(ownedWindows);
               }
           }
       }
       return result;
   }

}